# Contributing

When contributing to this repository, please first discuss the change you wish to make via issue,
email, or any other method with the owners of this repository before making a change. 

Please note we have a [code of conduct](https://github.com/RobotUnion/rallf-js-sdk/blob/master/.github/CODE_OF_CONDUCT.md), please follow it in all your interactions with the project.

## Pull Request Process
1. Ensure any install or build dependencies are removed before the end of the layer when doing a build.
2. Update the README.md and the wiki with details of changes, this includes changes to the init and runner commands, to the package.json _(if publishing is required)_, and the README.md to the new version that this Pull Request would represent. The versioning scheme we use is [SemVer](http://semver.org/).
4. Please make sure all test pass before pushing.

## Publishing to npm
If your contribution means it should be updated in npm, you must say so in the pull request, and if it goes correctly we will publish it ourselves.


## Creating issues
1. Please check your issue has not yet been reported.
2. Use a issue template when posible.
3. Make sure the issue explains the problem in a clear and concise way.
